def stampa_griglia (griglia) :
    print
    print "  123"
    ind_riga = 1
    while ind_riga <= 3 :
        riga = str(ind_riga) + "|"
        for elemento in griglia[ind_riga - 1] :
            riga = riga + elemento
        riga = riga + "|"
        print riga
        ind_riga = ind_riga + 1
    print


# Lo stato della partita e' codificato con i seguenti simboli:
# "O": ha vinto il giocatore con il simbolo "O"
# "X": ha vinto il giocatore con il simbolo "X"
# "C": la partita non e' terminata
# "P": la partita e' terminata con un pareggio

def stato_gioco (griglia) :
    
    # tre simboli allineati su una riga?
    for riga in griglia :
        if riga == ["O", "O", "O"] :
            return "O"
        if riga == ["X", "X", "X"] :
            return "X"

    # tre simboli allineati su una colonna?
    ind_colonna = 0
    while ind_colonna < 3 :
        if griglia[0][ind_colonna] == griglia[1][ind_colonna] and \
           griglia[1][ind_colonna] == griglia[2][ind_colonna] :
            if griglia[0][ind_colonna] == "O" :
                return "O"
            if griglia[0][ind_colonna] == "X" :
                return "X"
        ind_colonna = ind_colonna + 1

    # tre simboli allineati sulla diagonale "principale"?
    if griglia[0][0] == griglia[1][1] and \
       griglia[1][1] == griglia[2][2] :
            if griglia[0][0] == "O" :
                return "O"
            if griglia[0][0] == "X" :
                return "X"

    # tre simboli allineati sulla diagonale "secondaria"?
    if griglia[0][2] == griglia[1][1] and \
       griglia[1][1] == griglia[2][0] :
            if griglia[0][2] == "O" :
                return "O"
            if griglia[0][2] == "X" :
                return "X"

    # se ci sono caselle libere la partita continua
    for riga in griglia :
        for elemento in riga :
            if elemento == " " :
                return "C"

    # nessuno dei giocatori ha ancora vinto,
    # e non ci sono caselle libere: la partita
    # termina con un pareggio
    return "P"


# Inserimento di una mossa.
# L'argomento 'giocatore' deve corrispondere al simbolo
# di uno dei due giocatori, "O" oppure "X"

def mossa (griglia, giocatore) :
    coordinate = [1,2,3]
    mossa_valida = False
    while mossa_valida == False :
        print "Giocatore " + giocatore + ", scegli una casella:"
        riga = input("riga (1, 2, 3): ")
        colonna = input("colonna (1, 2, 3): ")
        if riga not in coordinate or colonna not in coordinate :
            print "Coordinate non valide!\n"
        elif griglia[riga - 1][colonna - 1] != " " :
            print "Casella gia' occupata!"
        else :
            mossa_valida = True
    # si crea una copia della griglia
    nuova_griglia = griglia[:]
    nuova_griglia[riga - 1][colonna - 1] = giocatore
    return nuova_griglia


# Programma principale

def tris () :
    print "GIOCO DEL TRIS"

    while True :
        griglia = [[" ", " ", " "], [" ", " ", " "], [" ", " ", " "]]
        stato_partita = "C"
        giocatore = "O"
        stampa_griglia(griglia)

        # ogni iterazione corrisponde alla scelta
        # di uno dei giocatori
        while stato_partita == "C" :
            mossa(griglia, giocatore)
            stampa_griglia(griglia)
            if giocatore == "O" :
                giocatore = "X"
            else :
                giocatore = "O"
            stato_partita = stato_gioco(griglia)

        if stato_partita != "P" :
            print "Ha vinto " + stato_partita + "!\n\n"
        else :
            print "La partita termina con un pareggio.\n\n"

        scelta = raw_input("Nuova partita? (S/N) ")
        if scelta != "S" and scelta != "s" :
            break

    print "\nArrivederci alla prossima partita.\n\n"
