class Studente :

    def __init__ (self, nome, cognome, CF, matricola, \
                  data_g, data_m, data_a) :
        self._nome = nome
        self._cognome = cognome
        self._CF = CF
        self._matricola = matricola
        self._data_immaticolazione = {'g':data_g, \
                                      'm':data_m, 'a':data_a}
        self._esami = list()

    def nome (self) :
        return self._nome

    def cognome (self) :
        return self._cognome

    def codice_fiscale (self) :
        return self._CF

    def matricola (self) :
        return self._matricola

    def data_immatricolazione (self) :
        return str(self._data_immaticolazione['g']) + "/" + \
               str(self._data_immaticolazione['m']) + "/" + \
               str(self._data_immaticolazione['a'])

    def elenco_esami (self) :
        if len(self._esami ) == 0 :
            print "\nNessun esame sostenuto.\n"
            return
        print "\nElenco degli esami:\n"
        for esame in self._esami :
            print esame['codice'], esame['data'],
            if esame['voto'] < 31 :
                print esame['voto']
            else :
                print "30 con lode"
        print

    def registrazione_esame (self, codice, data, voto) :
        esame = dict()
        esame['codice'] = codice
        esame['data'] = data
        esame['voto'] = voto
        self._esami = self._esami + [esame]


# Esempi:
# - per creare un'istanza:
#   s = Studente("Ugo", "Neri", "NRIUGO...", "12345", 1, 1, 2018)
# - per stampare gli esami sostenuti: s.elenco_esami()
# - per registrare un nuovo esame:
#   s.registrazione_esame("AAAAA", "1/1/2019", 23)
